:-retract_all(initiation(_, _)).
:-retract_all(termination(_, _)).
:-retract_all(happens(_, _)).
:-retract_all(tprop(_)).
:-retract_all(ram(_)).
:-retract_all(abducible(_)).
:-retract_all(constantfluent(_)).
:-retract_all(pprop(_, _, _)).
constantfluent(accesible_neighbors(_,_)).
constantfluent(animal(_)).
constantfluent(animal_is_large(_)).
constantfluent(animal_species(_,_)).
constantfluent(gate(_)).
constantfluent(gate_pos(_,_)).
constantfluent(location(_)).
constantfluent(neighbor_loc(_,_)).
constantfluent(neighbor_pos(_,_)).
constantfluent(pos_in_loc(_,_)).
constantfluent(position(_)).
constantfluent(ridable(_)).
constantfluent(species(_)).
constantfluent(species_is_large(_)).
happens(get_off_animal_to_position(john,elly,pos22), 3).
happens(mount_animal(john,elly), 1).
happens(move_to_position(elly,pos12), 2).
initiation(animal_ground_pos(A,P), T) :- 
	 happens(move_to_position(A,P), T), 
	 holds(animal(A), T), 
	 holds(position(P), T),
	 true.
initiation(animal_ground_pos(A,P), T) :- 
	 happens(pass_through_gate(A,G), T), 
	 holds(animal(A), T), 
	 holds(position(P), T), 
	 holds(position(P1), T), 
	 holds(\=(P,P1), T), 
	 holds(gate(G), T), 
	 holds(gate_pos(G,P), T), 
	 holds(gate_pos(G,P1), T), 
	 holds(animal_ground_pos(A,P1), T),
	 true.
initiation(animal_ground_pos(A1,P), T) :- 
	 happens(get_off_animal_to_position(A1,A2,P), T), 
	 holds(animal(A1), T), 
	 holds(animal(A2), T), 
	 holds(\=(A1,A2), T), 
	 holds(position(P), T),
	 true.
initiation(animal_ground_pos(A2,P), T) :- 
	 happens(throwoff(A1,A2), T), 
	 holds(animal(A1), T), 
	 holds(animal(A2), T), 
	 holds(\=(A1,A2), T), 
	 holds(position(P), T), 
	 holds(position(P1), T), 
	 holds(\=(P,P1), T), 
	 holds(animal_ground_pos(A1,P1), T), 
	 holds(accesible_neighbors(P,P1), T),
	 true.
initiation(gate_is_open(G), T) :- 
	 happens(open_gate(A,G), T), 
	 holds(animal(A), T), 
	 holds(gate(G), T),
	 true.
initiation(rides(A1,A2,P), T) :- 
	 happens(mount_animal(A1,A2,P), T), 
	 holds(animal(A1), T), 
	 holds(animal(A2), T), 
	 holds(\=(A1,A2), T), 
	 holds(position(P), T),
	 true.
pprop(close_gate(A,G),T,[holds(animal(A),T),holds(gate(G),T),holds(gate_is_open(G),T),holds(animal_is_near_gate(A,G),T)]).
pprop(get_off_animal_to_position(A1,A2,P),T,[holds(animal(A1),T),holds(animal(A2),T),holds(\=(A1,A2),T),holds(position(P),T),holds(rides(A1,A2),T),holds(reachable_by(A2,P),T)]).
pprop(mount_animal(A1,A2,P),T,[holds(animal(A1),T),holds(animal(A2),T),holds(\=(A1,A2),T),holds(animal_species(A1,human),T),holds(ridable(A2),T),holds(animal_is_large(A2),T),holds(animal_ground_pos(A2,P),T),holds(reachable_by(A1,P),T),neg(holds(rides(A1,A2),T))]).
pprop(move_to_position(A,P),T,[holds(animal(A),T),holds(position(P),T),holds(animal_species(A,human),T),neg(holds(rides(A),T))]).
pprop(move_to_position(A,P),T,[holds(animal(A),T),holds(position(P),T),holds(reachable_by(A,P),T)]).
pprop(open_gate(A,G),T,[holds(animal(A),T),holds(gate(G),T),neg(holds(gate_is_open(G),T)),holds(animal_is_near_gate(A,G),T)]).
pprop(pass_through_gate(A,G),T,[holds(animal(A),T),holds(gate(G),T),holds(animal_is_near_gate(A,G),T),holds(gate_is_open(G),T)]).
pprop(pass_through_gate(A,G),T,[holds(animal(A),T),holds(gate(G),T),holds(animal_species(A,human),T),neg(holds(rides(A),T))]).
pprop(throwoff(A1,A2),T,[holds(animal(A1),T),holds(animal(A2),T),holds(\=(A1,A2),T),holds(rides(A2,A1),T)]).
ram(holds(animal_is_near_gate(A,G), T)) :-  
	 holds(animal(A), T), 
	 holds(gate(G), T), 
	 holds(position(P), T), 
	 holds(gate_pos(G,P), T), 
	 holds(animal_ground_pos(A,P), T).
ram(holds(animal_pos(A,P), T)) :-  
	 holds(animal(A), T), 
	 holds(position(P), T), 
	 holds(animal_species(A,human), T), 
	 neg(holds(rides(A), T)), 
	 holds( animal_ground_pos(A,P), T).
ram(holds(animal_pos(A,P), T)) :-  
	 holds(animal(A), T), 
	 holds(position(P), T), 
	 neg(holds(animal_species(A,human), T)), 
	 holds( animal_ground_pos(A,P), T).
ram(holds(animal_pos(A1,P), T)) :-  
	 holds(animal(A1), T), 
	 holds(animal(A2), T), 
	 holds(\=(A1,A2), T), 
	 holds(position(P), T), 
	 holds(animal_species(A1,human), T), 
	 holds(ridable(A2), T), 
	 holds(rides(A1,A2,P), T).
ram(holds(reachable_by(A,P), T)) :-  
	 holds(animal(A), T), 
	 holds(position(P), T), 
	 holds(position(P1), T), 
	 holds(\=(P,P1), T), 
	 holds(animal_ground_pos(A,P1), T), 
	 holds(accesible_neighbors(P,P1), T).
ram(holds(rides(A1), T)) :-  
	 holds(animal(A1), T), 
	 holds(animal(A2), T), 
	 holds(\=(A1,A2), T), 
	 holds(animal_species(A1,human), T), 
	 holds(ridable(A2), T), 
	 holds(rides(A1,A2), T).
ram(holds(rides(A1,A2), T)) :-  
	 holds(animal(A1), T), 
	 holds(animal(A2), T), 
	 holds(\=(A1,A2), T), 
	 holds(animal_species(A1,human), T), 
	 holds(ridable(A2), T), 
	 holds(position(P), T), 
	 holds(rides(A1,A2,P), T).
ram(holds(rides(A1,A2,P), T)) :-  
	 holds(animal(A1), T), 
	 holds(animal(A2), T), 
	 holds(\=(A1,A2), T), 
	 holds(position(P), T), 
	 holds(animal_species(A1,human), T), 
	 holds(ridable(A2), T), 
	 holds(animal_ground_pos(A2,P), T), 
	 holds(rides(A1,A2), T).
ram(neg(holds(animal_ground_pos(A,P), T))) :-  
	 holds(animal(A), T), 
	 holds(animal_species(A,human), T), 
	 holds(position(P), T), 
	 holds(rides(A), T).
ram(neg(holds(animal_ground_pos(A,P), T))) :-  
	 holds(animal(A), T), 
	 holds(position(P), T), 
	 holds(position(P1), T), 
	 holds(\=(P,P1), T), 
	 holds(animal_ground_pos(A,P1), T).
ram(neg(holds(animal_is_near_gate(A,G), T))) :-  
	 holds(animal(A), T), 
	 holds(gate(G), T), 
	 holds(position(P1), T), 
	 holds(position(P2), T), 
	 holds(\=(P1,P2), T), 
	 holds(gate_pos(G,P1), T), 
	 holds(gate_pos(G,P2), T), 
	 neg(holds(animal_ground_pos(A,P1), T)), 
	 neg(holds(animal_ground_pos(A,P2), T)).
ram(neg(holds(animal_pos(A,P), T))) :-  
	 holds(animal(A), T), 
	 holds(position(P), T), 
	 holds(position(P1), T), 
	 holds(\=(P,P1), T), 
	 holds(animal_pos(A,P1), T).
ram(neg(holds(reachable_by(A,P), T))) :-  
	 holds(animal(A), T), 
	 holds(position(P), T), 
	 holds(animal_species(A,human), T), 
	 holds(rides(A), T).
ram(neg(holds(reachable_by(A,P), T))) :-  
	 holds(animal(A), T), 
	 holds(position(P), T), 
	 holds(position(P1), T), 
	 holds(animal_ground_pos(A,P1), T), 
	 neg(holds(accesible_neighbors(P,P1), T)).
ram(neg(holds(rides(A), T))) :-  
	 holds(animal(A), T), 
	 holds(animal_species(A,human), T), 
	 holds(position(P), T), 
	 holds(animal_ground_pos(A,P), T).
ram(neg(holds(rides(A1,A2), T))) :-  
	 holds(animal(A1), T), 
	 holds(animal(A2), T), 
	 holds(\=(A1,A2), T), 
	 holds(animal_species(A1,human), T), 
	 holds(ridable(A2), T), 
	 neg(holds(rides(A1), T)).
ram(neg(holds(rides(A1,A2), T))) :-  
	 holds(animal(A1), T), 
	 holds(animal(A2), T), 
	 holds(animal(A3), T), 
	 holds(\=(A1,A2), T), 
	 holds(\=(A1,A3), T), 
	 holds(\=(A2,A3), T), 
	 holds(animal_species(A1,human), T), 
	 holds(ridable(A2), T), 
	 holds(ridable(A3), T), 
	 holds(rides(A1,A3), T).
ram(neg(holds(rides(A1,A2,P), T))) :-  
	 holds(animal(A1), T), 
	 holds(animal(A2), T), 
	 holds(\=(A1,A2), T), 
	 holds(animal_species(A1,human), T), 
	 holds(ridable(A2), T), 
	 holds(position(P), T), 
	 neg(holds(rides(A1,A2), T)).
ram(neg(holds(rides(A1,A2,P), T))) :-  
	 holds(animal(A1), T), 
	 holds(animal(A2), T), 
	 holds(\=(A1,A2), T), 
	 holds(position(P), T), 
	 holds(position(P1), T), 
	 holds(\=(P,P1), T), 
	 holds(animal_species(A1,human), T), 
	 holds(ridable(A2), T), 
	 holds(rides(A1,A2,P1), T).
ram(neg(holds(true, T))) :-  
	 holds(animal(A), T), 
	 holds(rides(A), T), 
	 neg(holds(animal_species(A,human), T)).
ram(neg(holds(true, T))) :-  
	 holds(animal(A), T), 
	 holds(rides(A,A), T).
ram(neg(holds(true, T))) :-  
	 holds(animal(A), T), 
	 neg(holds(rides(A), T)), 
	 neg(holds(animal_ground_pos(A,pos11), T)), 
	 neg(holds(animal_ground_pos(A,pos12), T)), 
	 neg(holds(animal_ground_pos(A,pos13), T)), 
	 neg(holds(animal_ground_pos(A,pos21), T)), 
	 neg(holds(animal_ground_pos(A,pos22), T)), 
	 neg(holds(animal_ground_pos(A,pos23), T)).
ram(neg(holds(true, T))) :-  
	 holds(animal(A1), T), 
	 holds(animal(A2), T), 
	 holds(\=(A1,A2), T), 
	 holds(animal_species(A1,human), T), 
	 holds(ridable(A2), T), 
	 holds(rides(A1,A2), T), 
	 neg(holds(animal_is_large(A2), T)).
ram(neg(holds(true, T))) :-  
	 holds(animal(A1), T), 
	 holds(animal(A2), T), 
	 holds(\=(A1,A2), T), 
	 holds(animal_species(A1,human), T), 
	 holds(ridable(A2), T), 
	 holds(rides(A1,A2), T), 
	 neg(holds(rides(A1,A2,pos11), T)), 
	 neg(holds(rides(A1,A2,pos12), T)), 
	 neg(holds(rides(A1,A2,pos13), T)), 
	 neg(holds(rides(A1,A2,pos21), T)), 
	 neg(holds(rides(A1,A2,pos22), T)), 
	 neg(holds(rides(A1,A2,pos23), T)).
ram(neg(holds(true, T))) :-  
	 holds(animal(A1), T), 
	 holds(animal(A2), T), 
	 holds(\=(A1,A2), T), 
	 holds(position(P), T), 
	 holds(animal_is_large(A1), T), 
	 holds(animal_is_large(A2), T), 
	 holds(animal_ground_pos(A1,P), T), 
	 holds(animal_ground_pos(A2,P), T).
ram(neg(holds(true, T))) :-  
	 holds(animal(A1), T), 
	 holds(animal(A2), T), 
	 holds(\=(A1,A2), T), 
	 holds(position(P), T), 
	 holds(animal_species(A1,human), T), 
	 holds(ridable(A2), T), 
	 neg(holds(animal_ground_pos(A2,P), T)), 
	 holds( rides(A1,A2,P), T).
ram(neg(holds(true, T))) :-  
	 holds(animal(A1), T), 
	 holds(animal(A2), T), 
	 holds(\=(A1,A2), T), 
	 holds(rides(A1,A2), T), 
	 neg(holds(ridable(A2), T)).
ram(neg(holds(true, T))) :-  
	 holds(animal(A1), T), 
	 holds(animal_species(A1,human), T), 
	 holds(rides(A1), T), 
	 neg(holds(rides(A1,elly), T)), 
	 neg(holds(rides(A1,leo), T)).
termination(gate_is_open(G), T) :- 
	 happens(close_gate(A,G), T), 
	 holds(animal(A), T), 
	 holds(gate(G), T),
	 true.
tprop(holds(accesible_neighbors(pos11,pos12), 0)).
tprop(holds(accesible_neighbors(pos11,pos21), 0)).
tprop(holds(accesible_neighbors(pos12,pos11), 0)).
tprop(holds(accesible_neighbors(pos12,pos22), 0)).
tprop(holds(accesible_neighbors(pos13,pos23), 0)).
tprop(holds(accesible_neighbors(pos21,pos11), 0)).
tprop(holds(accesible_neighbors(pos21,pos22), 0)).
tprop(holds(accesible_neighbors(pos22,pos12), 0)).
tprop(holds(accesible_neighbors(pos22,pos21), 0)).
tprop(holds(accesible_neighbors(pos23,pos13), 0)).
tprop(holds(animal(elly), 0)).
tprop(holds(animal(john), 0)).
tprop(holds(animal(leo), 0)).
tprop(holds(animal_is_large(elly), 0)).
tprop(holds(animal_is_large(john), 0)).
tprop(holds(animal_is_large(leo), 0)).
tprop(holds(animal_species(elly,elephant), 0)).
tprop(holds(animal_species(john,human), 0)).
tprop(holds(animal_species(leo,lion), 0)).
tprop(holds(gate(gateAO), 0)).
tprop(holds(gate_pos(gateAO,pos12), 0)).
tprop(holds(gate_pos(gateAO,pos13), 0)).
tprop(holds(location(cageA), 0)).
tprop(holds(location(outside), 0)).
tprop(holds(neighbor_loc(cageA,outside), 0)).
tprop(holds(neighbor_pos(pos11,pos12), 0)).
tprop(holds(neighbor_pos(pos11,pos21), 0)).
tprop(holds(neighbor_pos(pos12,pos13), 0)).
tprop(holds(neighbor_pos(pos12,pos22), 0)).
tprop(holds(neighbor_pos(pos13,pos23), 0)).
tprop(holds(neighbor_pos(pos21,pos22), 0)).
tprop(holds(neighbor_pos(pos22,pos23), 0)).
tprop(holds(pos_in_loc(pos11,cageA), 0)).
tprop(holds(pos_in_loc(pos12,cageA), 0)).
tprop(holds(pos_in_loc(pos13,outside), 0)).
tprop(holds(pos_in_loc(pos21,cageA), 0)).
tprop(holds(pos_in_loc(pos22,cageA), 0)).
tprop(holds(pos_in_loc(pos23,outside), 0)).
tprop(holds(position(pos11), 0)).
tprop(holds(position(pos12), 0)).
tprop(holds(position(pos13), 0)).
tprop(holds(position(pos21), 0)).
tprop(holds(position(pos22), 0)).
tprop(holds(position(pos23), 0)).
tprop(holds(ridable(elly), 0)).
tprop(holds(ridable(leo), 0)).
tprop(holds(species(elephant), 0)).
tprop(holds(species(human), 0)).
tprop(holds(species(lion), 0)).
tprop(holds(species_is_large(elephant), 0)).
tprop(holds(species_is_large(human), 0)).
tprop(holds(species_is_large(lion), 0)).
