source config.tcl

#----------------------------------------------------------------------
# Find and load the eclipse package
#----------------------------------------------------------------------

switch $tcl_platform(platform) {
    unix {
	set tkecl(ECLIPSEDIR) $env(ECLIPSEDIR)
    }
    windows {
	package require registry
	set tkecl(ECLIPSEDIR) [registry get \
	    HKEY_LOCAL_MACHINE\\SOFTWARE\\IC-Parc\\Eclipse\\$tkecl(version) ECLIPSEDIR]
    }
    default {
	error "$tcl_platform(platform) not supported"
	exit
    }
}

lappend auto_path [file join $tkecl(ECLIPSEDIR) lib_tcl]


#----------------------------------------------------------------------
# Initialize Eclipse engine
#----------------------------------------------------------------------

package require eclipse

set tkecl(text_truncate) 1000

ec_init

ec_post_goal "ensure_loaded(library(toplevel))"

ec_resume

global toplevel_out_channel
set toplevel_out_channel [ec_queue_connect toplevel_out r]




